Whl[..]   word, stored hi,lo byte
Wlh[..]   word, stored lo,hi byte
B[..]     byte
interrupt routine :

/* 0060 */
  if B[2047]==1  ->  B[2047]=2,  return

/* 006e */
  B[2093]++
  if B[2093]>= 50(dec)
  {
    B[2093]=0
    if (Whl[209f])
      Whl[209f]--
    if (B[2092])
      B[2092]--
  }
  for (i=0 ; i<4 ; i++)
    if (B[2091-i])
      B[2091-i]--
  if B[208d]!=0xff  &&  Wlh[208c]
     Wlh[208c]--
  if B[208b]!=0xff
     Wlh[208a]++
/* 00cb */
  if B[2089]
  {
    B[2088]++
    if (B[2088]>=25(dec)
    {
      if (B[2088]>=50(dec)
      {
        B[2088]=0
        B[2002]&=f7
      }
      else
        B[2002]|=8
    }
    else
      B[2002]&=f7
  }
  else
  {
    B[2088]=0
    B[2002]|=8
  }
/* 00f5 */
  if (B[2085]==1)  && (B[2094]&2)==0  && (Whl[209f]==1)
  {                                                    
    Whl[209f]=Wlh[2012]    /* !!   hi lo reversal */
    W[2016]=0
    B[2084]++
    B[20a1]= 0xa1
    W[2086]=W[208a]
    W[208a]=0
  }
/* 013f */
  B[2051]<<=1
  inportb(2)
  inportb(4)
  inportb(4)
  inportb(4)
  if (inportb(4)&0x80)==0
  {
    B[2051]|=1
    if (B[2051]&0xf)==0xf
    {
      if (B[2006]&8)        /* toggle bit */
        B[2006]&=0xf7
      else
        B[2006]|=8
    }
  }
  for (i=0 ; i<8 ; i++)
    outportb(1, B[2001+i])
  outportb(5, B[2009])
  outportb(6, B[200a])
  outportb(2, B[200b])
  outportb(3, B[200c])
  outportb(4, B[200d])
  for (i=0 ; i<8 ; i++)
    B[2001]&=0x0d
  if (B[2047])
  {
    outportb(7, B[2047])
    return
  }
/* 0191 */



0d24  : calc  Wlh[par3]=B[par2]*Wlh[par1]
  Re=Wlh[par1]
  if (par4==0)  Reh=0
  Rd=B[par2]
  W[par3]=0
  while (Rd)
  {
    Rd>>=1
    if (carry)
    {
      Wlh[par3]+=Re
      if (carry)
      {
        Wlh[par3]=0xffff
        return
      }
    }
    Re<<=1
  }


0f96
  if (B[Rb]==0)
  {
    for (i=0 ; i<8 ; i++)
      B[2001+i] |= high(Rd)
    if (Re==0) Re=1777
    for (i=0 ; i<3 ; i++)
      B[ [Re++] ] &= low(Rd)
  }




0900  : dial number from buffer 2060,  outputptr=2076, inputptr=2075
   switch (state)
   {
     case 0:  /* 0913 */
       if B[2075]==B[2076]
         state=0
       else
       {
         B[2005]|=2
         if (B[2046]&1)
         {
           B[2001]|=2
           state=5, pause=2
         }
         else
         {
           B[2077]=B[[2076]]
           state++, pause=1
         }
       }
       break;

     case 1:  /* 092f pulse high */
       B[2007]|=08
       state++, pause=3
       break;

     case 2:  /* 093e pulse low*/
       B[2007]&=f7
       state++, pause=2
       break

     case 3:  /* 094d pulse count down */
       if (B[2077]--)  goto state1
       B[2006]|=2
       state++, pause=2d     : pause between digits = 45/50 seconds
       break
     case 4:  /* 0963 -> 09d5, next digit */
       if ([2076]==0x60)
          [2076]=0x74
       else
          [2076]--
       state=0;
       break;
     case 5:  /* 0974 */
       B[2003]|=8
       state++, pause=2
       break
     case 6:  /* 0983 : send tone ?? */
/* 173d is table containing indices into 2001 */
/* 173d is indexed by byte pointed to by 2076 */
       [2001+173d[2*[[2076]]]] &=0xfe
       [2001+173d[2*[[2076]]+1]] &=0xfe
       state++, pause=5
     case 7:  /* 09b6 */
       [2006]|=2
       [2002]|=2
       [2003]&=7
       for (i=0 ; i<8 ; i++)
         [2001+i]|=1
       goto state4    /* next digit */
   }
2046  bit0 =1:dtmf, =0:pulse
2060  20 byte input buffer containing phone number (1=1, 9=9, 10=0, ...)
2075  ptr to end of digit buffer
2076  ptr to current digit in buffer
2077  count down pulses when pulse dialing
2096  current state of dialing process
2091  timer when dialing (counted down by irq)
2001-2008  I/O stuff






0  037b    [2094]=40   007
1  037e    [2094]=41   060407
2  0381    [2094]=80   068008
3  0384    [2094]=43   0611
4  0387    [2094]=80   007
5  0372    [2094]=80   008      [20a2]=1

0  03a9    [2094]=00   007
1  03ac    [2094]=01   060407
2  03af    [2094]=03   068008
3  03b2    [2094]=03   0611
4  03b5    [2094]=20   007
5  03a0    [2094]=20   008      [20a2]=1
